<template>
  <ul class="body-metas information-list">
    <li v-if="history.isInterview">
      <span class="information-label">Type :</span> {{ type }}
    </li>
    <li v-if="history.reason">
      <span class="information-label">Motif :</span>
      {{ HELP_REQUEST_REASON_OPTIONS.get(history.reason) }}
    </li>
    <template v-if="isMinistryAgent">
      <li v-if="history.numero_pegase">
        <span class="information-label">Numéro Pégase :</span>
        {{ history.numero_pegase }}
      </li>
      <li v-if="history.ministre">
        <span class="information-label">Ministre :</span>
        {{ MINISTRE_OPTIONS.get(history.ministre) }}
      </li>
    </template>
    <li v-if="history.due_date">
      <span class="information-label">Date d'échéance :</span>
      {{ formatDate(history.due_date) }}
    </li>
    <li v-if="history.organisme_prescripteur">
      <span class="information-label">Organisme prescripteur :</span>
      {{ history.organisme_prescripteur.name }}
    </li>
    <li v-if="examiningOrganisation">
      <span class="information-label">Instruction :</span>
      {{ examiningOrganisation }}
    </li>
    <li v-if="history.asked_amount">
      <span class="information-label">Montant demandé :</span>
      {{ euros(history.asked_amount) }}
    </li>
    <li v-if="history.dispatch_date">
      <span class="information-label">Date d'envoi du dossier :</span>
      {{ formatDate(history.dispatch_date) }}
    </li>
    <li v-if="history.examination_date">
      <span class="information-label"> Date de passage en commission : </span>
      {{ formatDate(history.examination_date) }}
    </li>
    <li v-if="history.decision_date">
      <span class="information-label">Date de la décision :</span>
      {{ formatDate(history.decision_date) }}
    </li>
    <template v-if="history.status === ACCEPTED_STATUS_VALUE">
      <li v-if="allocatedAmount">
        <span class="information-label">Montant attribué :</span>
        {{ allocatedAmount }}
      </li>
      <li v-if="history.handling_date">
        <span class="information-label">Date de fin de prise en charge :</span>
        {{ formatDate(history.handling_date) }}
      </li>
    </template>
    <li v-if="hasRefusalReason">
      <span class="information-label">Motif du refus :</span>
      {{ history.refusal_reason }}
    </li>
    <li
      v-if="history.help_request"
      class="fr-icon-success-line"
    >
      Instruction de demande
    </li>
    <template v-if="isMinistryAgent">
      <li
        v-if="history.classified"
        class="fr-icon-success-line"
      >
        Classé
      </li>
      <li
        v-if="history.forwarded_to_justice"
        class="fr-icon-success-line"
      >
        Transmis à la justice
      </li>
      <li v-if="interventions">
        <span class="information-label">Interventions :</span>
        {{ interventions }}
      </li>
      <li v-if="signalements">
        <span class="information-label">Signalements :</span>
        {{ signalements }}
      </li>
    </template>
  </ul>
</template>

<script setup>
  import {
    ACCEPTED_STATUS_VALUE,
    HELP_REQUEST_REASON_OPTIONS,
    PAYMENT_METHOD_OPTIONS,
    REFUSED_STATUS_VALUE
  } from '~~/utils/constants/help-requests'
  import {
    INTERVIEW_INTERVENTION_OPTIONS,
    INTERVIEW_SIGNALEMENT_OPTIONS,
    INTERVIEW_TYPE_OPTIONS,
    OUTSIDE_INTERVIEW_TYPE_VALUE,
    WITH_THIRD_PERSON_INTERVIEW_TYPE_VALUE
  } from '~~/utils/constants/interview'
  import { MINISTRE_OPTIONS } from '~/utils/constants/ministry'
  import { euros, formatDate } from '~~/utils'

  const isMinistryAgent = useMinistryAgent()

  const props = defineProps({
    history: { type: Object, required: true }
  })

  const type = computed(() => {
    if (!props.history.isInterview) return ''
    const label = INTERVIEW_TYPE_OPTIONS.get(props.history.type)
    if (
      (props.history.type !== OUTSIDE_INTERVIEW_TYPE_VALUE ||
        !props.history.place) &&
      (props.history.type !== WITH_THIRD_PERSON_INTERVIEW_TYPE_VALUE ||
        !props.history.third_person_name)
    ) {
      return label
    }
    return `${label} - ${
      props.history.place || props.history.third_person_name
    }`
  })

  const examiningOrganisation = computed(() => {
    if (props.history.isInterview) return ''
    return props.history.external_organisation
      ? props.history.organisme_instructeur?.name || ''
      : 'Interne'
  })

  const allocatedAmount = computed(() => {
    if (props.history.isInterview) return ''
    let allocatedAmount = ''
    if (props.history.allocated_amount) {
      allocatedAmount += euros(props.history.allocated_amount)
    }
    if (props.history.payment_date || props.history.payment_method) {
      if (allocatedAmount) allocatedAmount += ' '
      allocatedAmount += '('
    }
    if (props.history.payment_date) {
      allocatedAmount += formatDate(props.history.payment_date)
      if (props.history.payment_method) allocatedAmount += ' - '
      else allocatedAmount += ')'
    }
    if (props.history.payment_method) {
      allocatedAmount += `${PAYMENT_METHOD_OPTIONS.get(
        props.history.payment_method
      )})`
    }
    return allocatedAmount
  })

  const hasRefusalReason = computed(
    () =>
      props.history.status === REFUSED_STATUS_VALUE &&
      props.history.refusal_reason
  )

  const interventions = computed(() =>
    props.history.interventions
      ?.map(i => INTERVIEW_INTERVENTION_OPTIONS.get(i))
      .join(', ')
  )

  const signalements = computed(() =>
    props.history.signalements
      ?.map(s => INTERVIEW_SIGNALEMENT_OPTIONS.get(s))
      .join(', ')
  )
</script>

<style scoped>
  .information-list {
    column-gap: 2rem;
    margin-bottom: 0.5rem;
    column-count: 2;
  }
</style>
